/*
 * generated by Xtext
 */
package com.datastax.devcenter.cql.ui

import com.datastax.devcenter.cql.BaseCqlContextProvider
import com.datastax.devcenter.cql.CqlContextProvider
import com.datastax.devcenter.cql.SchemaMode
import com.datastax.devcenter.cql.SchemaModeConfiguration
import com.datastax.devcenter.cql.ui.contentassist.CqlTemplateProposalProvider
import com.datastax.devcenter.cql.ui.contentassist.antlr.lexer.UICustomCqlLexer
import com.datastax.devcenter.cql.ui.contentassist.antlr.parser.CustomCqlParser
import com.datastax.devcenter.cql.ui.editor.CqlEditorPart
import com.datastax.devcenter.cql.ui.editor.folding.DevCenterFoldingRegionProvider
import com.datastax.devcenter.cql.ui.outline.ExpandedOutlinePage
import com.google.inject.Binder
import com.google.inject.name.Names
import org.eclipse.jface.text.ITextHover
import org.eclipse.xtend.lib.annotations.FinalFieldsConstructor
import org.eclipse.xtext.ide.editor.contentassist.antlr.IContentAssistParser
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.Lexer
import org.eclipse.xtext.ui.LexerUIBindings
import org.eclipse.xtext.ui.editor.XtextEditor
import org.eclipse.xtext.ui.editor.actions.IActionContributor
import org.eclipse.xtext.ui.editor.autoedit.AbstractEditStrategyProvider
import org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalPostProcessor
import org.eclipse.xtext.ui.editor.contentassist.IProposalConflictHelper
import org.eclipse.xtext.ui.editor.contentassist.ITemplateProposalProvider
import org.eclipse.xtext.ui.editor.folding.IFoldingRegionProvider
import org.eclipse.xtext.ui.editor.model.IResourceForEditorInputFactory
import org.eclipse.xtext.ui.editor.model.TerminalsTokenTypeToPartitionMapper
import org.eclipse.xtext.ui.editor.outline.impl.OutlinePage
import org.eclipse.xtext.ui.editor.preferences.IPreferenceStoreInitializer
import org.eclipse.xtext.ui.editor.syntaxcoloring.AbstractAntlrTokenToAttributeIdMapper
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightingConfiguration
import org.eclipse.xtext.ui.editor.syntaxcoloring.ISemanticHighlightingCalculator

/**
 * Use this class to register components to be used within the Eclipse IDE.
 */
@FinalFieldsConstructor class CqlUiModule extends AbstractCqlUiModule {
	
	override void configure(Binder binder) {
		super.configure(binder);
		binder.bindConstant().annotatedWith(SchemaModeConfiguration).to(SchemaMode.EFFECTIVE)
		binder.bind(CqlContextProvider).to(BaseCqlContextProvider).asEagerSingleton;
	} 
   
    @Override
    override Class<? extends IContentAssistParser> bindIContentAssistParser() {
        return typeof(CustomCqlParser);
    }

    def Class<? extends AbstractAntlrTokenToAttributeIdMapper> bindAbstractAntlrTokenToAttributeIdMapper() {
        return typeof(CqlAntlrTokenToAttributeIdMapper);
    }

    def Class<? extends IHighlightingConfiguration> bindIHighlightingConfiguration() {
        return typeof(CqlHighlightingConfiguration);
    }

    def Class<? extends ISemanticHighlightingCalculator> bindISemanticHighlightingCalculator() {
        return typeof(CqlSemanticHighlightingCalculator);
    }
    
    override void configureContentAssistLexer(Binder binder) {
    	
        binder.bind(Lexer)
            .annotatedWith(
                Names.named(
                	LexerUIBindings.CONTENT_ASSIST
                ))
            .to(UICustomCqlLexer);
    }
    
    def Class<? extends IFoldingRegionProvider> bindIFoldingRegionProvider() {
        return typeof(DevCenterFoldingRegionProvider);
    }

    @Override
    override Class<? extends ITemplateProposalProvider> bindITemplateProposalProvider() {
        return typeof(CqlTemplateProposalProvider);
    }

    def Class<? extends XtextEditor> bindXtextEditor() {
        return typeof(CqlEditorPart);
    }

    def Class<? extends OutlinePage> bindOutlinePage() {
        return typeof(ExpandedOutlinePage);
    }

    // Enable "mark occurrences" in the editor by default.
    // TODO find a way to toggle this with a key binding.
    @Override
    override void configureMarkOccurrencesAction(Binder binder) {
        binder.bind(IActionContributor).annotatedWith(Names.named("markOccurrences")).
        to(CqlMarkOccurrenceActionContributor);
        binder.bind(IPreferenceStoreInitializer).annotatedWith(Names.named("MydslMarkOccurrenceActionContributor")) //$NON-NLS-1$
            .to(CqlMarkOccurrenceActionContributor);
    }

    // CqlTerminalsTokenTypeToPartitionMapper and CqlAutoEditStrategyProvider make it possible for
    // STRING_LITERAL and QUOTED_NAME rules from the Cql grammar to be included in the
    // PartitionEndSkippingEditStrategy that skips a trailing terminal instead of inserting.
    def Class<? extends TerminalsTokenTypeToPartitionMapper> bindTerminalsTokenTypeToPartitionMapper() {
        return typeof(CqlTerminalsTokenTypeToPartitionMapper);
    }

    @Override
    override Class<? extends AbstractEditStrategyProvider> bindAbstractEditStrategyProvider() {
        return typeof(CqlAutoEditStrategyProvider);
    }

    @Override
    override Class<? extends ICompletionProposalPostProcessor> bindICompletionProposalPostProcessor() {
        return typeof(CqlCompletionProposalPostProcessor);
    }

    // Enable validation for workspace-external files. See DEVC-626.
    @Override
    override Class<? extends IResourceForEditorInputFactory> bindIResourceForEditorInputFactory() {
        return typeof(CqlJavaClassPathResourceForIEditorInputFactory);
    }

    @Override
    override Class<? extends ITextHover> bindITextHover() {
        return typeof(DevCenterCompositeHover);
    }
    
    override Class<? extends IProposalConflictHelper> bindIProposalConflictHelper() {
        return typeof(CustomProposalConflictHelper);
    }
    
}
